# -*- coding:utf-8 -*- 
from PyQt4.QtCore import (QEvent, Qt)
from PyQt4.QtGui import (QAction, QDialog, QMessageBox)
from ui_about import Ui_Dialog_About
from ui_navigator import Ui_Dialog_Viewer
from ui_catalogue import Ui_Dialog_Metadata
from ui_contacts import Ui_Dialog_Contact
from ui_options import Ui_Dialog_Options
from qsphere_tools import (makeGetOptions, MakePropertiesForWindow, MakeWindowIcon)

class DialogAbout(QDialog, Ui_Dialog_About):
	def __init__(self):
		QDialog.__init__(self)
		self.setupUi()
     
class DialogOptions(QDialog, Ui_Dialog_Options):
        def __init__(self, parent):
             QDialog.__init__(self)
             self.setObjectName("DialogOptions")
             self.setAccessibleName("DialogOptions")             
             self.parent = parent
             MakeWindowIcon(self, "qsphereoptions.png")
             MakePropertiesForWindow(self, self.parent)
             self.setupUi()

class DialogContacts(QDialog, Ui_Dialog_Contact):
        def __init__(self, parent, IsNotSoloMode):
             QDialog.__init__(self)
             self.setObjectName("DialogContacts")
             self.setAccessibleName("DialogContacts")
             MakeWindowIcon(self, "contact.png")
             MakePropertiesForWindow(self, parent)
             
             self.parent = parent
             self.notSoloMode = IsNotSoloMode
             self.setupUi()
             self.installEventFilter(self)

        def eventFilter(self, obj, event):
             if not event : return False
             if event == None : return False
             if event.type() == QEvent.WindowActivate : makeGetOptions(self)
             return QDialog.eventFilter(self, obj, event)
          

def LoadDialogViewer(self, iface, zUrl, zCond, zEmprise, langueTR, parent, senderBut, icon, isModal):
    d = DialogViewer(iface, zUrl, zCond, zEmprise, self.langueTR, parent, senderBut, isModal)
    MakePropertiesForWindow(d, d.parent) 
    MakeWindowIcon(d, icon) 
    if not isModal :
        d.setModal(False)
        d.show()
        return d
    else : d.exec_()

class DialogViewer(QDialog, Ui_Dialog_Viewer):
	def __init__(self, iface, zUrl, isXML, zEmprise, langueTR, parent, senderBut, isModal):
		QDialog.__init__(self)
		self.setObjectName("DialogViewer")
                self.setAccessibleName("DialogViewer")
		self.iface = iface
		self.langueTR = langueTR if langueTR in ("fr", "it", "fi", "es", "de") else "en"
		self.homeurl = zUrl                
		self.isXML = isXML
		self.emprise = zEmprise
		self.parent = parent
		self.senderBut = senderBut
		self.isModal = isModal
		self.setupUi()
		self.installEventFilter(self)


        def eventFilter(self, obj, event):
             if not event : return False
             if event == None : return False
             if event.type() == QEvent.WindowActivate : makeGetOptions(self)
             return QDialog.eventFilter(self, obj, event)    
		
		
class DialogMetadata(QDialog, Ui_Dialog_Metadata):
	def __init__(self, iface, langue, languageIndex, langs, langsDico, langueTR, formats, listCodecs, \
                     listTemporalSystem, listTypeRessources, listCountries, indexCountry, listCountriesCode, \
                     localeFullName, parent):
                QDialog.__init__(self)
                self.setObjectName("DialogMetadata")
                self.setAccessibleName("DialogMetadata")
                MakePropertiesForWindow(self, parent)
                self.parent = parent
                self.isFromDownload = None
                self.indexLang = self.MainPlugin.indexLang
                self.setupUi()
                self.installEventFilter(self)

             
        def eventFilter(self, obj, event):
             if not event : return False
             if event == None : return False
             if (event.type() == QEvent.KeyPress) :
                  if (event.key() == Qt.Key_F11) or (event.key() == Qt.Key_F12) :
                       myTable = None
                       if self.focusWidget().metaObject().className() in ("QTableWidget", "MyTableWidget"): myTable = self.focusWidget()
                       else :
                          try :
                              Obj = self.focusWidget().parent().parent()
                              if Obj.metaObject().className() in ("QTableWidget", "MyTableWidget"): myTable = Obj
                          except : pass

                       if myTable :  
                          zRacAction = "Ajouter" if (event.key() == Qt.Key_F11) else "Effacer"
                          if myTable.objectName()=="tableechelles" :
                               zCommand = self.findChild(QAction,"%s_8_%s" % (zRacAction, "grouperesolutionscale"))
                               if zCommand != None : zCommand.triggered.emit(True)
                          else :     
                               zCommand = self.findChild(QAction,"%s_6_%s" % (zRacAction, myTable.objectName()))
                               if zCommand != None : zCommand.triggered.emit(True); 
                 
             return QDialog.eventFilter(self, obj, event)  
               
