# -*- coding: utf-8 -*-
from PyQt4.QtCore import (QSize, QRect, Qt)
from PyQt4.QtGui import (QApplication, QBrush, QColor, QFrame, QImage, QLabel, QPalette, QPixmap, QTextEdit)
from qsphere_tools import (getThemeIcon, MakeWindowIcon, MakePropertiesForWindow, makeGetOptions)
from qsphere_objmaker import MyPushButton

class Ui_Dialog_About(object):
    def setupUi(self):
        self.setObjectName("dialogAbout")
        self._W,self._H = 530, 420
        self.setMaximumSize(QSize(self._W,self._H))
        self.setMaximumSize(QSize(self._W,self._H))        
        self.resize(QSize(QRect(0,0,self._W,self._H).size()).expandedTo(self.minimumSizeHint()))
        MakeWindowIcon(self, "sphery.png")
        
        self.label_2 = QLabel(self)
        self.label_2.setGeometry(10, 10, 400, 25)

        self.textEdit = QTextEdit(self)

        palette = QPalette()
        brush = QBrush(QColor(0,0,0,0))
        brush.setStyle(Qt.SolidPattern)
        palette.setBrush(QPalette.Active, QPalette.Base,brush)
        brush = QBrush(QColor(0,0,0,0))
        brush.setStyle(Qt.SolidPattern)
        palette.setBrush(QPalette.Inactive, QPalette.Base,brush)

        brush = QBrush(QColor(255,255,255))
        brush.setStyle(Qt.SolidPattern)
        palette.setBrush(QPalette.Disabled, QPalette.Base,brush)
        self.textEdit.setPalette(palette)
        self.textEdit.setAutoFillBackground(True)
        self.textEdit.width = 320
        self.textEdit.height = 380
        self.textEdit.setFrameShape(QFrame.NoFrame)
        self.textEdit.setFrameShadow(QFrame.Plain)
        self.textEdit.setReadOnly(True)
        self.textEdit.setObjectName("textEdit")
        self.textEdit.setTextInteractionFlags(Qt.TextBrowserInteraction)
        self.textEdit.setGeometry(10, 40, 200, 200)  

        
        self.labelImage = QLabel(self)
        myImgPath = getThemeIcon("aboutqsphere.png")
        carIcon = QImage(myImgPath)
        self.labelImage.setPixmap(QPixmap.fromImage(carIcon))
        self.labelImage.setGeometry(200, 10, 320, 310)


        zIcon = getThemeIcon("closebutton.png")
        zToolTip = QApplication.translate("QSphere","Close", None, QApplication.UnicodeUTF8)
        self.CloseButton = MyPushButton(self) 
        self.CloseButton.initPushButton(200, 25, 255, 340, "closeButton", "", zToolTip, True, zIcon, 100, 25, True)

        self.retranslateUi()
        self.CloseButton.clicked.connect(self.reject)
        

    def retranslateUi(self):
        zTitle = "QSphere"
        zVersion = "4.2.0"
        self.setWindowTitle(zTitle)
        self.label_2.setText("%s %s" % (zTitle, zVersion))
        zParagraphe0 = QApplication.translate("QSphere", "This extension", None, QApplication.UnicodeUTF8)
        zParagraphe1 = QApplication.translate("QSphere", "creates metdata in XML ISO standard", None, QApplication.UnicodeUTF8)
        zParagraphe2 = QApplication.translate("QSphere", "It is not part of the engine Qgis and any problem can not be addressed QGIS developers", None, QApplication.UnicodeUTF8)
        zAuteur0     = QApplication.translate("QSphere", "Author", None, QApplication.UnicodeUTF8)
        zDate        = QApplication.translate("QSphere", "code (october 2016)", None, QApplication.UnicodeUTF8)
        
        self.textEdit.setHtml("<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
        "p, li { white-space: pre-wrap; }\n"
        "</style></head><body style=\" font-family:\'Sans Serif\'; font-size:8pt; font-weight:400; font-style:normal;\">\n"
        "<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-family:\'MS Shell Dlg 2\'; font-size:8pt;\">"
        "<span style=\" font-weight:600;\">%s</span> %s .... %s.</p></td></tr></table>"
        "<p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"></p>\n"
        "<p style=\"margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">"
        "<font color='#0000FF'><b><u>%s</u></b></font><br><br>"
        "<b>M. MASSE Christophe</b>."
        "<br><br><i>%s.</i></p></body></html>" % (zParagraphe0, zParagraphe1, zParagraphe2, zAuteur0, zDate))

