# -*- coding:utf-8 -*-
#/* Type Safari 5.1 to 6.0 */
from PyQt4 import uic
from PyQt4.QtCore import (QBuffer, QByteArray, QEventLoop, QFile, QFileInfo, QIODevice, QObject, Qt, QRect, QSize, QUrl, pyqtSlot, pyqtSignal, SIGNAL)
from PyQt4.QtGui import (QAction, QApplication, QComboBox, QFileDialog, QFont, QGroupBox, QHBoxLayout, QImage, QIcon, QKeySequence, QLabel, QLineEdit,
                         QMdiArea, QMenu, QMessageBox, QMovie, QPainter, QPixmap, QPrinter, QPrintPreviewDialog, QPushButton,
                         QRadioButton, QSizePolicy, QTabWidget, QTableWidget, QTextEdit, QWidget) 
from PyQt4.QtWebKit import (QWebInspector, QWebPage, QWebSettings, QWebView)
from qgis.gui import QgsMessageBar
from qsphere_tools import (ChangeButtonIcon, CorrigePath, FileIsRaster, FileNameWithExtension, FixeLabelsFileDialog, LoadFile,
                           LoadSimpleData, MakeFileInfosToHTML, MakeWindowIcon, MarkerText,
                           NetHTML, SendMessage, convertSTR, convertSize, fileRessourceExist, getThemeIcon, getWidget,
                           listdirectory, makeGetOptions, makeHelp, makeListXSLT)

from qsphere_objmaker import (MyPushButton, MyTableWidget, MyTextEdit, MyWebComboBox)
from os.path import (basename, dirname, exists, join, splitext)
from cStringIO import StringIO
from xmlISOparser import xmlISOparser
from PyQt4.QtXmlPatterns import QXmlQuery
from PyQt4.QtNetwork import (QNetworkAccessManager, QNetworkReply, QNetworkRequest, QNetworkCookieJar)

from codecs import open as codecsopen
from xml.etree import ElementTree as ET
from webbrowser import open as webbrowseropen
from urlparse import urlparse
from urllib import (urlencode, unquote_plus, unquote)

class Ui_Dialog_Viewer(object):
    def setupUi(self):
        self._W, self._H, self.minwidth, self.minheight = 900, 800, 500, 90
        self.resize(QSize(QRect(0,0,self._W,self._H).size()).expandedTo(self.minimumSizeHint()))
        self.setWindowFlags(Qt.WindowMaximizeButtonHint | Qt.WindowMinimizeButtonHint)

        self.ListOfqueryURL = LoadSimpleData(self, "file:/ressources/query_url.csv")
        if self.ListOfqueryURL == [] : self.ListOfqueryURL = ["xml_iso19139?uuid", "iso19139.xml?id", "importerDonnees.do?importer", "importerDonnees.do;jsessionid", "xml.metadata.get?id", "xml.metadata.get?uuid"]
    
        self.initDir = ""
        self.initDirSearchFiles = ""
        self.oldurl = ""
        self.d = {}

        zSizeW = self.width()-20
        zSizeH = self.height()-50
        self.fileExtension = ".html"

        makeGetOptions(self)
        
        self.Listfiltres = ("All (*.htm*)", "HTML (*.html)", "HTM (*.htm)")
        self.HTML = ""
        self.countfiles, self.countdirs = 0, 0
               
        self.labeleURL = QLabel(self)
        self.labeleURL.setGeometry(QRect(10, 15,  50, 25))
        self.labeleURL.setText("URL : ")
        self.labeleURL.setAlignment(Qt.AlignRight)

        self.eURL = MyWebComboBox(self) 
        self.eURL.setEditable(True)
        self.eURL.setInsertPolicy(QComboBox.InsertAlphabetically)
        self.eURL.textChanged.connect(self.eURL.VerifExpReg)

        self.mainTabWidget = QTabWidget(self)
        self.mainTabWidget.setObjectName("mainTabWidget")
        self.mainTabWidget.setTabPosition(QTabWidget.North) 
        self.mainTabWidget.setTabShape(QTabWidget.Rounded)
        self.mainTabWidget.setUsesScrollButtons(True)
        self.mainTabWidget.setTabsClosable(True)
        self.mainTabWidget.setMovable(True)
        self.mainTabWidget.setDocumentMode(True)

        self.mainTabWidget.tabCloseRequested.connect(self.closeTabs)
        self.mainTabWidget.currentChanged.connect(self.changeURL)

        self.myPathIconvRightArrow, self.myPathIconvLeftArrow = "rightarrow.png", "leftarrow.png"
        self.myPathHome, self.myPathGoURL = "home.png", "gourl.png"
        self.myPathLoadXML, self.myPathLoadHTML = "loadxml.png", "loadxml.png"
        self.myPathPrint, self.myPathLoadFiles, self.myPathSave = "print.png", "open.png", "save.png"
        self.myReloadPage, self.myFilesNavigator, self.mySearchMenu = "reloadpage.png", "filesnavigator_true.png", "searchmenu.png"
        self.myPathEdit, self.myWaitingGIF = "editxml.png", "sablier.gif"        

        self.tabWidget = self.addNewPage()
        self.mainTabWidget.addTab(self.tabWidget, QIcon(getThemeIcon("webpage.png")), "Page %s" % self.mainTabWidget.count())

        self.BackButton = MyPushButton(self)
        self.BackButton.initPushButton(24, 24, 5, 5, "BackButton", "", QApplication.translate("QSphere", "Previous page", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myPathIconvLeftArrow), 24, 24, True)
        self.BackButton.setShortcut(QKeySequence("F2"))

        self.FowardButton = MyPushButton(self)
        self.FowardButton.initPushButton(24, 24, 5, 5, "FowardButton", "", QApplication.translate("QSphere", "Next page", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myPathIconvRightArrow), 24, 24, True)
        self.FowardButton.setShortcut(QKeySequence("F3"))

        self.goURL = MyPushButton(self)
        self.goURL.initPushButton(24, 24, 5, 5, "goURL", "", QApplication.translate("QSphere", "Go url", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myPathGoURL), 24, 24, True)

        self.addTabPage  = MyPushButton(self)
        self.addTabPage.initPushButton(24, 24, 5, 5, "addTabPage", "", QApplication.translate("QSphere", "Add a new tab", None, QApplication.UnicodeUTF8), True, getThemeIcon("webpageadd.png"), 24, 24, True)
        self.addTabPage.setShortcut(QKeySequence("Ctrl+Shift+W"))
        
        self.AccueilButton = MyPushButton(self)
        self.AccueilButton.initPushButton(24, 24, 5, 5, "AccueilButton", "", QApplication.translate("QSphere", "Home page", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myPathHome), 24, 24, True)
        self.AccueilButton.setShortcut(QKeySequence("Ctrl+H"))

        self.ReloadButton = MyPushButton(self)
        self.ReloadButton.initPushButton(24, 24, 5, 5, "ReloadButton", "", QApplication.translate("QSphere", "Reload page", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myReloadPage), 24, 24, True)
        self.ReloadButton.setShortcut(QKeySequence("F5"))

        self.LoadButton = MyPushButton(self)
        self.LoadButton.initPushButton(24, 24, 5, 5, "LoadButton", "", QApplication.translate("QSphere", "Open Files", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myPathLoadFiles), 24, 24, True)
        self.LoadButton.setShortcut(QKeySequence("Ctrl+O"))

        self.PrintButton = MyPushButton(self)
        self.PrintButton.initPushButton(24, 24, 5, 5, "PrintButton", "", QApplication.translate("QSphere", "Print", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myPathPrint), 24, 24, True)
        self.PrintButton.setShortcut(QKeySequence("Ctrl+P"))
                
        self.SaveButton = MyPushButton(self)
        self.SaveButton.initPushButton(24, 24, 5, 5, "SaveButton", "", QApplication.translate("QSphere", "Save XML as HTML File", None, QApplication.UnicodeUTF8), True, getThemeIcon(self.myPathSave), 24, 24, True)
        self.SaveButton.setShortcut(QKeySequence("Ctrl+S"))

        self.CloseButton = QPushButton(self)
        self.CloseButton.setObjectName("CloseButton")
        self.CloseButton.setText(QApplication.translate("QSphere", "Close", None, QApplication.UnicodeUTF8))

        zIcon = getThemeIcon("qspherehelp.png")
        self.HelpButton = MyPushButton(self) 
        self.HelpButton.initPushButton(48, 48, -50, -50, "HelpButton", "", "", True, zIcon, 48, 48, True)
        self.HelpButton.setShortcut(QKeySequence("F1")) 
       
        self.filter = "*.xml" 
        self.listeXSLT = makeListXSLT(self)

        self.movie = QMovie(getThemeIcon(self.myWaitingGIF))

        self.groupBoxParamsXML = QGroupBox(self)
        self.groupBoxParamsXML.setTitle("%s : " % QApplication.translate("QSphere", "XML Params", None, QApplication.UnicodeUTF8))

        self.labelPrimaryXSLT = QLabel(self.groupBoxParamsXML)
        self.labelPrimaryXSLT.setText("%s : " % QApplication.translate("QSphere", "Primary XSLT", None, QApplication.UnicodeUTF8))
        self.labelPrimaryXSLT.setAlignment(Qt.AlignRight)
        self.PrimaryXSLT = QComboBox(self.groupBoxParamsXML)
        self.PrimaryXSLT.addItems(self.listeXSLT)
        
        self.labelSecondaryXSLT = QLabel(self.groupBoxParamsXML)
        self.labelSecondaryXSLT.setText("%s : " %  QApplication.translate("QSphere", "Secondary XSLT", None, QApplication.UnicodeUTF8))
        self.labelSecondaryXSLT.setAlignment(Qt.AlignRight)
        self.SecondaryXSLT = QComboBox(self.groupBoxParamsXML)
        self.SecondaryXSLT.addItems(self.listeXSLT)

        self.labelPrimaryXSLT.setGeometry(10, 15, 100, 25)
        self.PrimaryXSLT.setGeometry(110, 10, 150, 25)
        self.labelSecondaryXSLT.setGeometry(270, 15, 100, 25)
        self.SecondaryXSLT.setGeometry(380, 10, 150, 25)


        font = QFont()
        font.setPointSize(7) 
        font.setWeight(8) 
        font.setBold(True)

        self.labelResultFiles = QLabel(self)
        self.labelResultFiles.setAlignment(Qt.AlignLeft)
        self.labelResultFiles.setObjectName("labelResultFiles")
        self.labelResultFiles.setText("")
        self.labelResultFiles.setFont(font)
        self.labelResultFiles.setStyleSheet(" QLabel {background-color: white;  border-width: 2px; border-radius: 10px; text-align: center; margin-top: 5px;}")
        self.labelResultFiles.setVisible(False)   

        self.movie = QMovie(getThemeIcon("attente.gif"))
        self.status_txt = QLabel(self)
        self.status_txt.setMovie(self.movie)
        self.status_txt.setLayout(QHBoxLayout())
        self.status_txt.layout().addWidget(QLabel(''))
        self.status_txt.setVisible(False)

        self.barInfo = QgsMessageBar(self)
        self.barInfo.setSizePolicy( QSizePolicy.Minimum, QSizePolicy.Fixed )

        zTest, zValue = fileRessourceExist(self, "xml/xsl/transformation_%s.xsl" % (self.langueTR))

        if self.parent != None :
            if self.parent.objectName()=="DialogContacts" :
                if self.homeurl != "" :
                    if self.homeurl.startswith("filexml:") :
                       zFile = self.homeurl.replace("filexml:", "")
                       if exists(zFile) :
                            myISO = xmlISOparser(zFile, None, 'MEDDE', self.langueTR)
                            zCond = myISO.getTagDictionnary()
                            if not zCond : zTest, zValue = fileRessourceExist(self, "xml/xsl/contacts_%s.xsl" % (self.langueTR))

        if zValue != "" : zValue = basename(zValue)
        zIndex = self.listeXSLT.index(zValue) if zValue in (self.listeXSLT) else 0
        self.PrimaryXSLT.setCurrentIndex(zIndex)

        zTest, zValue = fileRessourceExist(self, "xml/xsl/iso19115_%s.xsl" % (self.langueTR))
        if zValue != "" : zValue = basename(zValue)
        zIndex = self.listeXSLT.index(zValue) if zValue in (self.listeXSLT) else 0
        self.SecondaryXSLT.setCurrentIndex(zIndex)
       
        self.LoadButton.clicked.connect(self.loadTheFile)
        self.PrimaryXSLT.currentIndexChanged[str].connect(self.reloadPageURL)
        self.SecondaryXSLT.currentIndexChanged[str].connect(self.reloadPageURL)
        self.PrintButton.clicked.connect(self.printhelp)

        self.BackButton.clicked.connect(self.go_back)
        self.AccueilButton.clicked.connect(self.go_accueil)
        self.addTabPage.clicked.connect(self.addNewTab)
        self.goURL.clicked.connect(self.go_url)
        self.ReloadButton.clicked.connect(self.reloadPageURL)
        self.FowardButton.clicked.connect(self.go_forward)

        self.mainTabWidget.currentWidget().viewHTML.urlChanged.connect(self.changePageURL)
        self.mainTabWidget.currentWidget().viewHTML.linkClicked.connect(self.changePageURL)

        self.SaveButton.clicked.connect(self.SaveHTML)
        self.HelpButton.clicked.connect(self.clickHelp)
        self.CloseButton.clicked.connect(self.closeme)

        if self.homeurl == "" : self.eURL.currentIndexChanged[str].connect(self.go_url)

        self.eURL.addItems(sorted(self.serverNavigator))
        if self.homeurl != "" :
            if self.eURL.findText(self.homeurl)==-1 : self.eURL.addItem(self.homeurl)
            self.eURL.setCurrentIndex(self.eURL.findText(self.homeurl))
            self.go_url()
            self.eURL.currentIndexChanged[str].connect(self.go_url)    
        else : self.homeurl = self.eURL.currentText()   


    def closeTabs(self, int):
        if int > 0 :
            self.mainTabWidget.removeTab(int)
        else :
            zTitle = QApplication.translate("QSphere","Warning", None, QApplication.UnicodeUTF8)
            zMsg = QApplication.translate("QSphere","This tab can't be close.\nWould you like to clear content ?", None, QApplication.UnicodeUTF8)
            if QMessageBox.question(self, zTitle, zMsg, QApplication.translate("QSphere","Yes", None, QApplication.UnicodeUTF8), QApplication.translate("QSphere","No", None, QApplication.UnicodeUTF8)) ==  0 :
               self.eURL.setCurrentIndex(self.eURL.findText("#blank"))
               self.go_url()

    def changeURL(self, int):
        if self.mainTabWidget.currentWidget().viewHTML.lastURL == "": self.mainTabWidget.currentWidget().viewHTML.lastURL = "#blank"
        self.eURL.blockSignals(True)
        if type(self.mainTabWidget.currentWidget().viewHTML.lastURL) != str :
           try : self.eURL.setCurrentIndex(self.eURL.findText(self.mainTabWidget.currentWidget().viewHTML.lastURL.toString()))
           except : self.eURL.setCurrentIndex(self.eURL.findText(self.mainTabWidget.currentWidget().viewHTML.lastURL))   
        else : self.eURL.setCurrentIndex(self.eURL.findText(self.mainTabWidget.currentWidget().viewHTML.lastURL))   
        self.eURL.blockSignals(False)

    def addNewTab(self):
        self.tabWidget = self.addNewPage()
        self.mainTabWidget.addTab(self.tabWidget, QIcon(getThemeIcon("webpage.png")), "Page %s" % self.mainTabWidget.count())
        self.mainTabWidget.setCurrentIndex(self.mainTabWidget.count()-1)

    def addNewPage(self):

        zSizeW = self.width()-20
        zSizeH = self.height()-50
        
        tabWidget = QTabWidget(self)
        tabWidget.setObjectName("tabWidget")
        tabWidget.setStyleSheet(
            "QTabBar::tab:selected {color: black; background-color: rgb(255,255,255); font: 75 12pt 'Arial Rounded MT Bold'; border: 1px solid black; text-decoration: underline;}"
            "QTabBar::tab:!selected {color: rgb(255,255,255); background-color: #5D5D5D;border-bottom-color: #5D5D5D;}"
            "QTabWidget:pane {margin: 1px,1px,1px,1px;background-color: rgb(255,255,255);}"
            "QTabBar::tab {background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1, stop: 0 #cccccc, stop: 1 #5D5D5D);  border-width: 2px; border-radius: 10px; border-color: black; height: 36px;width: 180px;}"
            "QTabWidget{background-color: rgb(0, 0, 0); font: 75 10pt 'Arial Rounded MT Bold';}"
            "QTabWidget::tab-bar {left: 5px; bottom: 0px;background-color: rgb(255,255,255);}"
            "QTabBar::scroller {width: 0px;}"
        )
        tabWidget.setTabPosition(QTabWidget.South) 
        tabWidget.setTabShape(QTabWidget.Rounded)
        tabWidget.setMovable(True)
        tabWidget.setUsesScrollButtons(True)
        
        zTitle = ("Page", QApplication.translate("QSphere", "Analyzer", None, QApplication.UnicodeUTF8))
        zToolTip = (QApplication.translate("QSphere", "HTML page for help", None, QApplication.UnicodeUTF8), QApplication.translate("QSphere", "HTML page analyzer", None, QApplication.UnicodeUTF8))
        zIcons = ("pageweb.png", "pageanalyse.png")

        tabWidget.setIconSize(QSize(64, 32))

        for i in range(1,len(zTitle)+1):
            zTab = QWidget(self)
            zTab.setObjectName("tab%s" % (i))
            zTab.setAccessibleName(zTitle[i-1])
            tabWidget.addTab(zTab, QIcon(getThemeIcon(zIcons[i-1])), zTitle[i-1])
            tabWidget.setTabToolTip(i-1, zToolTip[i-1])

            if i == 1:
                tabWidget.viewHTML = WebView(self.mainTabWidget, zTab, self) 
                tabWidget.viewHTML.initWebView(self, self.parent, self.duration_info, self.duration_warning)
                tabWidget.viewHTML.setGeometry(0, 0, self.mainTabWidget.width()-5, self.mainTabWidget.height()-20)
                tabWidget.viewHTML.setObjectName("viewHTML")
                tabWidget.viewHTML.setAccessibleName("viewHTML")
                tabWidget.viewHTML.settings().setAttribute(QWebSettings.JavaEnabled, True)
                tabWidget.viewHTML.settings().setAttribute(QWebSettings.PluginsEnabled, True)
                tabWidget.viewHTML.settings().setAttribute(QWebSettings.AutoLoadImages, True)
                tabWidget.viewHTML.settings().setAttribute(QWebSettings.LocalContentCanAccessRemoteUrls, True)
                tabWidget.viewHTML.settings().setAttribute(QWebSettings.JavascriptEnabled, True)
                tabWidget.viewHTML.settings().setAttribute(QWebSettings.DeveloperExtrasEnabled, True)
                tabWidget.viewHTML.settings().setAttribute(QWebSettings.LinksIncludedInFocusChain, True)
                tabWidget.viewHTML.setRenderHints(QPainter.Antialiasing | QPainter.SmoothPixmapTransform)
                tabWidget.viewHTML.page().setLinkDelegationPolicy(QWebPage.DelegateAllLinks)
                tabWidget.viewHTML.page().setForwardUnsupportedContent(True)
                self.manager = QNetworkAccessManager(tabWidget.viewHTML)
                self.jar = QNetworkCookieJar(self.manager)
                self.manager.setCookieJar(self.jar)
                
            elif i == 2:
                tabWidget.inspector = QWebInspector(zTab)
                tabWidget.inspector.setGeometry(0, 0, self.mainTabWidget.width()-5, self.mainTabWidget.height()-20)
                tabWidget.inspector.setPage(tabWidget.viewHTML.page())
                tabWidget.inspector.show()
                tabWidget.inspector.setVisible(True)

        return tabWidget       


    def saveCurrentFilters(self):
        fichier = join(dirname(__file__), "ressources/filters_search.csv") 
        with codecsopen(fichier,'w','utf8') as f:
             for index in range(self.Filters.model().rowCount()):
                 if self.Filters.itemText(index)!= "" : f.write( "\"%s\"\n" % (self.Filters.itemText(index)))
        if f!= None : f.close()
        
        zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
        zMsg = QApplication.translate("QSphere","The file ini was saved as", None, QApplication.UnicodeUTF8)
        SendMessage(self, zTitle , "%s :<br><u><i>%s</i></ul>" % (zMsg, fichier), QgsMessageBar.INFO, self.duration_info)
    def clickHelp(self): makeHelp(self)
    
    def startMovie(self):
        self.status_txt.setVisible(True)
        self.movie.start()
        self.status_txt.repaint()

    def stopMovie(self):
        self.movie.stop()
        self.status_txt.setVisible(False)

    def reject(self): self.killWindow()
    def closeme(self): self.killWindow()
    def killWindow(self):
        if self.parent != None  and not self.isModal :
           if self.senderBut != None :
              if self.senderBut.objectName().startswith("help_") : ChangeButtonIcon(self.parent, self.senderBut,"info.png", 24, 24)
           try :   
               if (self) in self.parent.childswindows :
                   self.parent.childswindows.remove(self)
                   self.parent.nb_window_childs.setText("%s" % (len(self.parent.childswindows)))
           except: pass
           try : self.parent.windowsNoMDIChilds.remove(self)
           except : pass
           self.parent.webNavigator = None
        self.d = {}
        self.reject()
        
    def printhelp(self):
        printer = QPrinter() 
        printer.setPageSize(QPrinter.A4)
        printer.setOrientation(QPrinter.Portrait) if self.isXML else printer.setOrientation(QPrinter.Landscape)
        printer.setPageMargins(5, 10, 5, 10, QPrinter.Millimeter) if self.fileExtension == ".xml" else printer.setPageMargins(10, 10, 10, 10, QPrinter.Millimeter)
        printer.setOutputFormat(QPrinter.NativeFormat)
        printDialog = QPrintPreviewDialog(printer)
        MakeWindowIcon(printDialog, self.myPathPrint)
        printDialog.setWindowTitle(QApplication.translate("QSphere", "Print current page", None, QApplication.UnicodeUTF8))
        printDialog.setWindowFlags(Qt.WindowMaximizeButtonHint)
        printDialog.paintRequested.connect(self.mainTabWidget.currentWidget().viewHTML.print_)
        printDialog.exec_()     

        
    def resizeEvent(self,ev):
        zSize = ev.size()
        
        self.BackButton.setGeometry(65, 10, 25, 25)
        self.FowardButton.setGeometry(95, 10, 60, 25)
        self.eURL.setGeometry(125, 10,  zSize.width()-380, 25)
        self.goURL.setGeometry(zSize.width()-240, 10, 60, 25)
        self.addTabPage.setGeometry(zSize.width()-210, 10, 60, 25)
        self.AccueilButton.setGeometry(zSize.width()-180, 10, 60, 25)
        self.ReloadButton.setGeometry(zSize.width()-150, 10, 60, 25)
        self.LoadButton.setGeometry(zSize.width()-120, 10, 60, 25)
        self.PrintButton.setGeometry(zSize.width()-90, 10, 60, 25)
        self.SaveButton.setGeometry(zSize.width()-60, 10, 60, 25)
        
        self.status_txt.setGeometry(int(zSize.width()/2)-64, int(zSize.height()/2)-64, 64, 64)
        self.labelResultFiles.setGeometry(int(zSize.width()/2)-50, int(zSize.height()/2)-40, 32, 20) 
        self.mainTabWidget.setGeometry(10, 40, self.width()-20, self.height()-90)
        self.groupBoxParamsXML.setGeometry(10, self.height()-45, self.width()-200, 40)
        
        orindex = self.mainTabWidget.currentIndex()
        for i in range(self.mainTabWidget.count()):
            self.mainTabWidget.setCurrentIndex(i)
            zTab = self.mainTabWidget.currentWidget()
            zTab.setGeometry(10, 10, self.mainTabWidget.width()-20, self.mainTabWidget.height()-20)
            zTab.viewHTML.setGeometry(0, 0, self.mainTabWidget.width()-10, self.mainTabWidget.height()-20)
            zTab.inspector.setGeometry(0, 0, self.mainTabWidget.width()-10, self.mainTabWidget.height()-20)
            
        self.mainTabWidget.setCurrentIndex(orindex)
        self.barInfo.setGeometry(0, 40, zSize.width(), 90)    
        self.CloseButton.setGeometry(zSize.width()-120, zSize.height()-30, 100, 25)

    def reloadPageURL(self):
        self.mainTabWidget.currentWidget().viewHTML.pageAction(QWebPage.Reload)
        self.go_url()
        
    def go_back(self):
        self.mainTabWidget.currentWidget().viewHTML.history().back()
        zUrl = "%s" % (unicode(self.mainTabWidget.currentWidget().viewHTML.history().currentItem().url().toString()))
        if self.eURL.findText(zUrl)==-1 : self.eURL.addItem(zUrl)
        self.eURL.setCurrentIndex(self.eURL.findText(zUrl))
        FixeEnabledHistory(self, self.mainTabWidget.currentWidget().viewHTML)
        
    def go_forward(self):
        self.mainTabWidget.currentWidget().viewHTML.history().forward()
        zUrl = "%s" % (unicode(self.mainTabWidget.currentWidget().viewHTML.history().currentItem().url().toString()))
        if self.eURL.findText(zUrl)==-1 : self.eURL.addItem(zUrl)
        self.eURL.setCurrentIndex(self.eURL.findText(zUrl))        
        FixeEnabledHistory(self, self.mainTabWidget.currentWidget().viewHTML)

    def SaveHTML(self):
        if self.HTML.find('javascript') != -1 :
            zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
            zMsg1 = QApplication.translate("QSphere","Javascript detected ! Risk of trouble with the HTML save ...", None, QApplication.UnicodeUTF8)
            zMsg2 = QApplication.translate("QSphere","Choose another XSLT for saving in HTML format.", None, QApplication.UnicodeUTF8)
            SendMessage(self, zTitle , "%s<br>%s" % (zMsg1, zMsg2), QgsMessageBar.WARNING, self.duration_warning)
            return
        zUrl = self.eURL.currentText() 
        InitDir = dirname(zUrl) if self.initDir == "" else self.initDir
        InitDir = CorrigePath(InitDir)
        fileName, fileExtension = splitext(zUrl)
        NameFile = basename(zUrl).split(".")[0]
        InitDir = "%s%s%s" % (InitDir,NameFile.rsplit(".",1)[0], ".html")

        zTitle = QApplication.translate("QSphere","Save as a HTML file", None, QApplication.UnicodeUTF8)
        MyFileDialog = QFileDialog(self, zTitle)
        MyFileDialog.setNameFilters(self.Listfiltres)
        MyFileDialog.setDefaultSuffix("html")
        MyFileDialog.setViewMode(QFileDialog.Detail)
        MyFileDialog.setDirectory(InitDir)
        MyFileDialog.selectFile(NameFile)
        MyFileDialog.setAcceptMode(QFileDialog.AcceptSave)
        
        FixeLabelsFileDialog(self, MyFileDialog, 1, True)
        
        if MyFileDialog.exec_():
            fileName = FileNameWithExtension(self, MyFileDialog.selectedFiles()[0], MyFileDialog.selectedNameFilter())
            zHTML = self.HTML.encode(encoding='cp1252',errors='strict') 
            zLOG = open(fileName, "w")
            try :
                zLOG.write(unquote_plus(zHTML))
                zTitleMsg = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
                zSuccess = QApplication.translate("QSphere","Successfull !", None, QApplication.UnicodeUTF8)
                SendMessage(self, zTitleMsg , "%s :<br>%s<br>%s" % (zTitle, fileName, zSuccess) , QgsMessageBar.INFO, self.duration_info)                
            except :
                try :
                    zLOG.write("%s" % (zHTML))
                    zTitleMsg = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
                    zSuccess = QApplication.translate("QSphere","Successfull !", None, QApplication.UnicodeUTF8)
                    SendMessage(self, zTitleMsg , "%s :<br>%s<br>%s" % (zTitle, fileName, zSuccess) , QgsMessageBar.INFO, self.duration_info)
                except :
                    zLOG.write("<html><style>h1 {	font-size: 1.5em;}</style><h1>error</h1></html>")
                    zTitleMsg = QApplication.translate("QSphere","Warning", None, QApplication.UnicodeUTF8)
                    zSuccess = QApplication.translate("QSphere","Error", None, QApplication.UnicodeUTF8)
                    SendMessage(self, zTitleMsg , "%s :<br>%s<br>%s" % (zTitle, fileName, zSuccess) , QgsMessageBar.WARNING, self.duration_warning)
                                                      
            if zLOG != None : zLOG.close()
            
      
    def go_url(self):
        zUrl = self.eURL.currentText()
        if zUrl == "" : return
        if not zUrl.startswith("file:") and zUrl.startswith("filexml:") and zUrl.startswith("fileHTML:") and zUrl.startswith("about:") :    
            if (zUrl[0:7] != "http://" and zUrl[0:6] != "ftp://" and zUrl[0:8] != "https://") and not(exists(zUrl.split("#")[0])) :
                zUrl = "http://%s" % (zUrl) if zUrl != "" else zUrl
                if self.eURL.findText(zUrl)==-1 : self.eURL.addItem(zUrl)
                self.eURL.setCurrentIndex(self.eURL.findText(zUrl))
            if self.eURL.styleSheet() == "background-color:red;" and not exists(zUrl.split("#")[0]) :
               zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8) 
               zMsg = QApplication.translate("QSphere","Invalid URL ! Use open function if necessary for local resources ...", None, QApplication.UnicodeUTF8)
               SendMessage(self, zTitle , zMsg, QgsMessageBar.WARNING, self.duration_warning)
               return
        else :
                ActiveLink(self, zUrl, False, self.mainTabWidget.currentWidget().viewHTML)
                self.setWindowTitle(zUrl)
                return
            
        if self.eURL.currentText() != "" and self.eURL.styleSheet()!="background-color:red;" :
            ActiveLink(self, self.eURL.currentText(), False, self.mainTabWidget.currentWidget().viewHTML)
        else :
            if self.eURL.currentText() != "" :
                zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
                zMsg = QApplication.translate("QSphere","URL not natively supported ! Use open function if necessary for local resources ...", None, QApplication.UnicodeUTF8)
                SendMessage(self, zTitle , zMsg, QgsMessageBar.WARNING, self.duration_warning)


    def selfActiveLink(self, fileName):
        if exists(fileName) :
            zFile = QFileInfo(fileName)
            zRac = "filexml:" if zFile.suffix().lower() in ("xml", "qss") else ""
            self.homeurl = "%s%s" % (zRac, fileName.replace("\\", "/"))
            FixeEnabledHistory(self, self.mainTabWidget.currentWidget().viewHTML)
            zIndex = self.eURL.findText(self.homeurl)
            if zIndex == -1 :
                self.eURL.addItem(self.homeurl)
                zIndex = self.eURL.findText(self.homeurl)
            self.eURL.setCurrentIndex(zIndex)
    
    def loadTheFile(self):
        zTitle = QApplication.translate("QSphere","View a file (XML ISO 19139, HTML ...)", None, QApplication.UnicodeUTF8)
        InitDir = dirname(__file__) if self.initDir == "" else self.initDir
        MyFileDialog = QFileDialog(self, zTitle)
        zElt0 = QApplication.translate("QSphere","files", None, QApplication.UnicodeUTF8).title()
        zElt1 = QApplication.translate("QSphere","project", None, QApplication.UnicodeUTF8).title()
        MyFileDialog.setNameFilters(("%s Web (*.htm* *.xml)" % (zElt0), "%s HTML (*.htm*)" % (zElt0), "%s eXtensible Markup Language (*.xml *.XML)" % (zElt0), "%s QSphere (*.qsp)" % (zElt1), \
                                     "%s QSphere (*.qsr)" % (zElt0), "%s QSphere (*.qss)" % (zElt0), "%s CSV (*.csv)" % (zElt0), "%s PDF (*.pdf)" % (zElt0))) 
        MyFileDialog.setViewMode(QFileDialog.Detail)
        MyFileDialog.setDirectory(InitDir)
        MyFileDialog.setFileMode(QFileDialog.ExistingFile) 
        MyFileDialog.setAcceptMode(QFileDialog.AcceptOpen)

        FixeLabelsFileDialog(self, MyFileDialog, 0, True)
        
        if MyFileDialog.exec_():
            fileName = "%s" % (MyFileDialog.selectedFiles()[0])
            if fileName!="" : self.endLoadTheFile(fileName)

    def endLoadTheFile(self, fileName):
        if exists(fileName): 
            zSuffix = QFileInfo(fileName).suffix().lower()
            if zSuffix == "pdf" :
               self.mainTabWidget.currentWidget().viewHTML.ToOpenURL = fileName
               self.mainTabWidget.currentWidget().viewHTML.MakeOpenURL()
            else : self.selfActiveLink(fileName)
            self.initDir = dirname(fileName)
        else :  ActiveLink(self, fileName, False, self.mainTabWidget.currentWidget().viewHTML)   


    def go_accueil(self):
        FixeEnabledHistory(self, self.mainTabWidget.currentWidget().viewHTML)
        ActiveLink(self, self.homeurl, False, self.mainTabWidget.currentWidget().viewHTML)

    def changePageURL(self):
        zPage = self.mainTabWidget.currentWidget().viewHTML.page()
        linkact = zPage.action(QWebPage.OpenLink)


class Timeout(Exception):
    """A timeout (usually on page load) has been reached."""
           
class MyWebPage(QWebPage):
    formSubmitted = pyqtSignal(QUrl)

    def _events_loop(self, wait=0.01):
        self.application.processEvents()
        time.sleep(wait)    
    
    def __init__(self, dialog, parent=None):
        super(MyWebPage, self).__init__(parent)
        self.dialog = dialog
        self.mainFrame().javaScriptWindowObjectCleared.connect(self.refreshJS) 
        self.mainFrame().loadFinished.connect(self._on_load_finished)
        self.mainFrame().loadStarted.connect(self._on_load_started)
        self.headers = []
        self._load_timeout = -1
        self._load_success = False
        self.setSettings()        

    def setSettings(self):
        self.settings().setAttribute(QWebSettings.LocalStorageDatabaseEnabled, True)
        self.settings().setAttribute(QWebSettings.JavascriptCanOpenWindows, True)
        self.settings().setAttribute(QWebSettings.AutoLoadImages, False)        

    def setHeaders(self, headers): self.headers = headers

    def _on_load_started(self):
        self._load_success = False
        self._load_last = 0
        self.dialog.startMovie()
        self.dialog.labelResultFiles.setVisible(True)
  
    def _on_load_finished(self):
        self._load_success = True
        self.dialog.labelResultFiles.setVisible(False)
        self.dialog.stopMovie()
            
    def refreshJS(self): self.mainFrame().addToJavaScriptWindowObject('APP', self)

    def make_request(self, url):
        url = QUrl(url)
        req = QNetworkRequest(url)
        for header in self.headers:
            val = self.headers[header]
            req.setRawHeader(header, val)
        return req


    def load(self, url, headers=None, body=None, load_timeout=-1, delay=None):
        if not headers: self.headers = []
        if not body: body = ""
        req = self.make_request(url)
        self._load_success = False
        self._load_timeout = load_timeout
  
        self.mainFrame().load(req, QNetworkAccessManager.GetOperation, body)
        self._wait_finish()
        if delay: self.wait_delays(delay)
  
    def _wait_finish(self):
        while not self._load_success:
            self._events_loop()
            self._load_last += 1
            if self._load_timeout > 0 and self._load_last >= self._load_timeout * 100:
                raise Timeout("Timeout reached: %d seconds" % self._load_timeout)
  
    def wait_delays(self, seconds):
  
        for j in range(1, seconds):
            for i in range(1, 100):
                self._wait_finish()
                self._events_loop()
    
    def html(self): return unicode(self.mainFrame().toHtml())

    def acceptNavigationRequest(self, frame, req, nav_type):
        zElts, zQueryURL, zTestQUERY = req.url().toString().split("/"), [], False
        zQueryURL = zElts[-1].split("=")

        if zQueryURL != [] :
           if zQueryURL[0] in self.parent.dialog.ListOfqueryURL : zTestQUERY = True
           if zTestQUERY :
              self.parent.mainTabWidget.currentWidget().viewHTML.telech = Telecharge(req.url(), self.parent.dialog, None, "*.xml", self.parent.dialog.duration_info, self.parent.dialog.duration_warning, False)
              self.parent.mainTabWidget.currentWidget().viewHTML.telech.fintelecharge.connect(self.parent.mainTabWidget.currentWidget().viewHTML.telecharge_ok)
              if  self.parent.objectName() == "tempoViewer" : self.parent.close()
              return super(MyWebPage, self).acceptNavigationRequest(frame, req, nav_type)
        
        if nav_type == QWebPage.NavigationTypeFormSubmitted:
            self.properties = {}
            for header in req.rawHeaderList(): self.properties["%s" % (header)] = "%s" % (req.rawHeader(header))
            self.formSubmitted.emit(req.url())
        return super(MyWebPage, self).acceptNavigationRequest(frame, req, nav_type)

    
class WebView(QWebView):
    def __init__(self, mainTabWidget, parent, dialog):
        QWebView.__init__(self, parent)
        self.ToCopy = ""
        self.current_url = QUrl("")
        self.lastURL = "#blank"
        self.fileName = self.TypeMime = None
        self.parent = parent
        self.dialog = dialog
        self.mainTabWidget = mainTabWidget
        self.setContextMenuPolicy(Qt.CustomContextMenu)
        self.customContextMenuRequested.connect(self.context_menu_requested)

        self.setPage(MyWebPage(self.dialog))

        self.page().setLinkDelegationPolicy(QWebPage.DelegateAllLinks)
        self.page().parent = self
        self.page().unsupportedContent.connect(self.unsupportedContent)
        self.page().linkClicked.connect(self.GoLink) 
        self.page().formSubmitted.connect(self.handleFormSubmitted)

        self.isPageOkLoaded = False
        self.page().loadProgress.connect(self.progressPage)
        self.loadFinished.connect(self.changeNameTab)


    def progressPage(self, progress):
        if not self.isPageOkLoaded :
            self.dialog.labelResultFiles.setText("%s %%" % progress)
            self.dialog.labelResultFiles.repaint()
            
            if progress == 100 :
                self.dialog.labelResultFiles.setVisible(False)
                self.dialog.stopMovie()


    def changeNameTab(self, isOkLoaded):
        title = QApplication.translate("QSphere", "No title", None, QApplication.UnicodeUTF8)
        if self.title()!="": title = self.title()
        else :
            try : title = basename(self.mainTabWidget.parent().eURL.currentText()) 
            except : pass
            if title in ("", "#blank"): title = QApplication.translate("QSphere", "No title", None, QApplication.UnicodeUTF8) 
        self.mainTabWidget.setTabText(self.mainTabWidget.currentIndex(), title)
        self.mainTabWidget.setTabIcon(self.mainTabWidget.currentIndex(), self.icon())

    def createWindow(self, windowType):
        if windowType == QWebPage.WebBrowserWindow:
            self.webView = WebView()
            self.webView.setObjectName("tempoViewer")
            self.webView.dialog = self.dialog 
            self.webView.Metadata = self.Metadata 
            self.webView.duration_info = self.duration_info
            self.webView.duration_warning = self.duration_warning 
            self.webView.setAttribute(Qt.WA_DeleteOnClose, True)
            return self.webView
        return super(WebView, self).createWindow(windowType)

    def handleFormSubmitted(self, url):
        path = url.path()
        if path.lower().find("search") == -1 :
            zDoc = self.page().mainFrame()
            inputs = zDoc.findAllElements("input")
            data, fileName = {}, ""
            for item in  inputs :
                data[item.attribute("name")] = item.attribute("value")
                if item.attribute("name") == "nom" : fileName = item.attribute("value")

            if data != {} : data = urlencode(data)
            headers = {"Content-Type" : "application/x-www-form-urlencoded"}
            performUrl = "%s?%s" % (url.toString(), data)
            data = None
            self.telech = Telecharge(QUrl(performUrl), self.dialog, fileName, "*.zip", self.duration_info, self.duration_warning, False)
            self.telech.fintelecharge.connect(self.mainTabWidget.currentWidget().viewHTML.telecharge_ok)
        

    def initWebView(self, zDialog, metadata, duration_info, duration_warning):
        self.dialog = zDialog
        self.Metadata = metadata
        self.duration_info = duration_info
        self.duration_warning = duration_warning
        
    def context_menu_requested(self, point):
        self.imageurl = None
        context_menu = QMenu()
        page = self.page()
        frame = page.currentFrame()
        if unicode(self.selectedText()):
            menuIcon = getThemeIcon("copier.png")
            zText = (QApplication.translate("QSphere", "Copy", None, QApplication.UnicodeUTF8))
            self.copy = context_menu.addAction(QIcon(menuIcon), zText)
            self.ToCopy = unicode(self.selectedText())
            self.copy.triggered.connect(self.MakeToCopy)

            zTableWidget = ("tablelocalisator", "tableformats", "tablemotsclefsf","tableemprises","tablespecifications")
            zNameTableWidget = ("Identificator", "Format", "Mot clef", "Emprise", "Specification")
            zTableWidgetCols = ((0,1), (0,2), (0,2), (0,1,2,3), (0,2))

            Subsend_menu = menuTableWidget = []
            counterMenu = 0
           
            if self.Metadata != None and self.Metadata.objectName() in ("DialogMetaData", "formTableWidget") : #self.Metadata.objectName() == "DialogMetaData" : 

               if self.Metadata.objectName() == "DialogMetaData" : 

                    Emprise = unicode(self.selectedText()).split(",")

                    if len(Emprise)== 4 :

                        zText = QApplication.translate("QSphere", "Send to", None, QApplication.UnicodeUTF8)
                        send_menu = QMenu(zText)
                        menuIcon = getThemeIcon("sendtometadata.png")
                        self.ToSendto = unicode(self.selectedText())

                        zTextComp = QApplication.translate("QSphere", "Add an extent", None, QApplication.UnicodeUTF8)
                        self.sendto_newE = context_menu.addAction(QIcon(menuIcon), "%s" % (zTextComp))
                        self.sendto_newE.setObjectName("Ajouter_6_tableemprises")
                        self.sendto_newE.triggered.connect(self.SendToNewParentWidget)

                        zIndex = self.Metadata.tabWidget.currentIndex()

                        zObj = self.Metadata.findChild(MyTableWidget, "tableemprises")
                        if zObj :
                           for line in range(zObj.rowCount()):
                              if zObj.rowCount()> 1 :     
                                  zAction = send_menu.addAction(QIcon(menuIcon), "%s %s" % ("Emprise", line))
                                  zAction.setObjectName("%s %s %s" % ("tableemprises", line, 0))
                                  zAction.triggered.connect(self.SendToParentWidget)                             


                        context_menu.addMenu(send_menu)
                        self.Metadata.tabWidget.setCurrentIndex(zIndex) 

               elif self.Metadata.objectName() == "formTableWidget" :

                    menuIcon = getThemeIcon("sendtometadata.png")
                    zText = QApplication.translate("QSphere", "Send to", None, QApplication.UnicodeUTF8)
                    zTextComp = QApplication.translate("QSphere", "Extent", None, QApplication.UnicodeUTF8) 
                    zAction = context_menu.addAction(QIcon(menuIcon), "%s %s" % (zText, zTextComp))
                    zAction.setObjectName("%s %s %s" % (self.Metadata.objectName(), 0, 0))
                    zAction.triggered.connect(self.SendToParentWidgetExtent)
                    self.ToSendto = unicode(self.selectedText())

                    menuIcon = getThemeIcon("sendtometadata.png")
                    zText = QApplication.translate("QSphere", "Send to", None, QApplication.UnicodeUTF8)
                    zTextComp = QApplication.translate("QSphere", "Form view", None, QApplication.UnicodeUTF8) 
                    zAction = context_menu.addAction(QIcon(menuIcon), "%s %s" % (zText, zTextComp))
                    zAction.setObjectName("%s %s %s" % (self.Metadata.objectName(), "formWizard", 0))
                    zAction.triggered.connect(self.SendToFormWizardWidget)
                    self.ToSendto = unicode(self.selectedText())                    
                    
            elif self.Metadata != None and self.Metadata.objectName() =="ViewerTableWidget" :

                 zText = QApplication.translate("QSphere", "Send to", None, QApplication.UnicodeUTF8)
       
                 send_menu = QMenu(zText)
                 menuIcon = getThemeIcon("sendtometadata.png")
                 self.ToSendto = unicode(self.selectedText())
                 
                 zActionRac = QApplication.translate("QSphere", "Add a ", None, QApplication.UnicodeUTF8)
                 zTextComp = "Item"
                 if self.Metadata.tableWidget.objectName() in zTableWidget :
                    i = zTableWidget.index(self.Metadata.tableWidget.objectName())
                    zTextComp = zNameTableWidget[i]
                    
                    self.sendto_newF = context_menu.addAction(QIcon(menuIcon), "%s %s" % (zActionRac, zTextComp))
                    self.sendto_newF.setObjectName("Ajouter_6_%s" % self.Metadata.tableWidget.objectName())
                    self.sendto_newF.triggered.connect(self.SendToNewParentWidget)

                 zObj = getWidget(self.Metadata, self.Metadata.tableWidget.objectName())
                 if zObj :
                       if self.Metadata.tableWidget.objectName() in zTableWidget :
                           i = zTableWidget.index(self.Metadata.tableWidget.objectName())
                           for line in range(zObj.rowCount()):
                               if self.Metadata.tableWidget.objectName() != "tableemprises" :
                                   Subsend_menu.append(QMenu("%s %s" % (zNameTableWidget[i], line)) )
                                   for col in range(len(zTableWidgetCols[i])):
                                       zTextComp = zObj.horizontalHeaderItem(zTableWidgetCols[i][col]).text() 
                                       zAction = send_menu.addAction(QIcon(menuIcon), "%s %s" % (zTextComp, line))
                                       zAction.setObjectName("%s %s %s" % (zTableWidget[i], line, zTableWidgetCols[i][col]))
                                       zAction.triggered.connect(self.SendToParentWidget)
                                   counterMenu+= 1
                               else :
                                   if zObj.rowCount()>= 1 :     
                                      zAction = send_menu.addAction(QIcon(menuIcon), "%s %s" % (zNameTableWidget[i], line))
                                      zAction.setObjectName("%s %s %s" % (zTableWidget[i], line, 0))
                                      zAction.triggered.connect(self.SendToParentWidget)

                 context_menu.addMenu(send_menu)

        hit_test = frame.hitTestContent(point)
        
        if unicode(hit_test.linkUrl().toString()):
            menuIcon = getThemeIcon("copierlink.png")

            zText = QApplication.translate("QSphere", "Open link in new tab", None, QApplication.UnicodeUTF8)
            self.openURLinNewTab = context_menu.addAction(QIcon(menuIcon), zText)
            self.ToOpenURL = unicode(hit_test.linkUrl().toString())
            self.openURLinNewTab.triggered.connect(self.MakeOpenLink)

            zText = QApplication.translate("QSphere", "Open link in my default navigator", None, QApplication.UnicodeUTF8)
            self.openURL = context_menu.addAction(QIcon(menuIcon), zText)
            self.ToOpenURL = unicode(hit_test.linkUrl().toString())
            self.openURL.triggered.connect(self.MakeOpenURL)

            zText = QApplication.translate("QSphere", "Force open link", None, QApplication.UnicodeUTF8)
            self.openLink = context_menu.addAction(QIcon(menuIcon), zText)
            self.ToOpenLink = unicode(hit_test.linkUrl().toString())
            self.openLink.triggered.connect(self.MakeOpenLink)

            context_menu.addSeparator()

            zText = (QApplication.translate("QSphere", "Copy link", None, QApplication.UnicodeUTF8))
            self.copyURL = context_menu.addAction(QIcon(menuIcon), zText)
            self.ToCopyURL = unicode(hit_test.linkUrl().toString())
            self.copyURL.triggered.connect(self.MakeToCopyURL)

            
        context_menu.addSeparator()

           
        menuIcon = getThemeIcon("selectall.png")
        zText = (QApplication.translate("QSphere", "Select all", None, QApplication.UnicodeUTF8))
        self.selall = QAction(QIcon(menuIcon), zText, self)
        context_menu.addAction(self.selall)
        self.selall.triggered.connect(self.SelectAll)
        
        context_menu.addSeparator()
        
        menuIcon = getThemeIcon("coller.png")
        zText = (QApplication.translate("QSphere", "Paste", None, QApplication.UnicodeUTF8))
        self.paste = QAction(QIcon(menuIcon), zText, self)
        context_menu.addAction(self.paste)
        self.paste.triggered.connect(self.MakeToPaste)
        
        if unicode(page.mainFrame().hitTestContent(point).element().tagName()).lower()== "img":
            self.imageurl =  page.mainFrame().hitTestContent(point).imageUrl()
            tempoSRC = page.mainFrame().hitTestContent(point).element().attribute("src")
            tempoSRC = tempoSRC.replace("\\","/")

            if tempoSRC!="" :
               self.fileName = tempoSRC.rsplit("/",1)[1]
               self.TypeMime = "*.%s" % (self.fileName.rsplit(".",1)[1])
            
            context_menu.addSeparator()

            menuIcon = getThemeIcon("saveas.png")
            zText = (QApplication.translate("QSphere", "Save image as ...", None, QApplication.UnicodeUTF8))
            self.downloadimg = QAction(QIcon(menuIcon), zText, self)
            context_menu.addAction(self.downloadimg)
            self.downloadimg.triggered.connect(self.DownloadImg)

            self.paste.setEnabled(False)
   
        context_menu.exec_(self.mapToGlobal(point))


    def DownloadImg(self):
        self.telech = Telecharge(self.imageurl, self.dialog, self.fileName, self.TypeMime, self.duration_info, self.duration_warning, True)
        self.telech.fintelecharge.connect(self.telecharge_ok)


    def unsupportedContent(self, reply, outfd=None):
        if not reply.error():
            url = self.current_url.toString()
            try : 
                zElts = urlparse(url)
                zFile = zElts.path.split("/")[-1]
                zExtension = zFile.split(".")[-1]
            except : zFile, zExtension = "", "*"    
           
            self.telech = Telecharge(reply.url(), self.dialog, zFile, "*.%s" % (zExtension), self.duration_info, self.duration_warning, False)
            self.telech.fintelecharge.connect(self.telecharge_ok)
        else :
            zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
            zMsg = QApplication.translate("QSphere","Error on unsupported content :", None, QApplication.UnicodeUTF8)
            SendMessage(self.dialog, zTitle , "%s %s" % (zMsg, reply.errorString()), QgsMessageBar.WARNING, self.duration_warning)


    def telecharge_ok(self, ok):
        if ok:
            zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
            zMsg = QApplication.translate("QSphere","Donwload success ! File save as :", None, QApplication.UnicodeUTF8)
            SendMessage(self.dialog, zTitle , "%s %s" % (zMsg, self.fileName), QgsMessageBar.INFO, self.duration_info)
        else:
            zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
            zMsg = QApplication.translate("QSphere","Donwload error ! File not save ...", None, QApplication.UnicodeUTF8)
            SendMessage(self.dialog, zTitle , zMsg, QgsMessageBar.WARNING, self.duration_warning)


    def SendToNewParentWidget(self):
        zActionName = self.sender().objectName()
        zButWidget = getWidget(self.Metadata, zActionName)
        
        if zButWidget or not zButWidget :
           zActionName = zActionName.split("_")[2]
           zWidget = getWidget(self.Metadata, zActionName)
           if zWidget :
              if zActionName == "tableemprises":
                 zEmprise = self.ToSendto.split(",")
                 if len(zEmprise)!= 4 : return
                 else :
                    self.Metadata.AddLine()
                    zLine = zWidget.rowCount()-1
                    self.FixeValuesForEmprise(zWidget, zLine, zEmprise, True)
              else :
                 self.Metadata.AddLine()
                 zLine = zWidget.rowCount()-1
                 zWidget.cellWidget(zLine, 0).setText(self.ToSendto)

    def SendToFormWizardWidget(self):
        zEmprise = self.ToSendto.split(",")
        if len(zEmprise)!= 4 : return
        self.FixeValuesForEmprise(None, 0, zEmprise, False)

       
    def SendToParentWidgetExtent(self):
        zEmprise = self.ToSendto.split(",")
        if len(zEmprise)!= 4 : return

        zActionName, zWidget, zLine = "", None, 0
        
        for child in self.Metadata.children():
            if child.metaObject().className() == "MySpinBox" :
               zActionName = child.objectName()
               zInfos = zActionName.split("_") 
               zActionName = zInfos[0]
               zWidget = getWidget(self.Metadata.parent, zActionName)
               break
            
        if zWidget :
           zLine = zWidget.currentRow()
           self.FixeValuesForEmprise(zWidget, zLine, zEmprise, True)
           self.FixeValuesForEmprise(None, 0, zEmprise, False)

        
    def SendToParentWidget(self):
        zActionName = self.sender().objectName()
        if zActionName.find(" ") :
           zInfos = zActionName.split(" ") 
           zActionName = zInfos[0]
        zWidget = getWidget(self.Metadata, zActionName)
        if zWidget :
           if type(zWidget) == QLineEdit: zWidget.setText(self.ToSendto)
           elif type(zWidget)in (QTextEdit, MyTextEdit) : zWidget.setPlainText(self.ToSendto)
           elif type(zWidget) in (QTableWidget, MyTableWidget) :
               if len(zInfos)== 3 : zCol = int(zInfos[2])
               zLine = int(zInfos[1])
               if zActionName == "tableemprises" :
                  zEmprise = self.ToSendto.split(",")
                  if len(zEmprise)!= 4 : return
                  else :  self.FixeValuesForEmprise(zWidget, zLine, zEmprise, True)
               else :
                  zWidget.cellWidget(zLine, zCol).setText(self.ToSendto)

    def FixeValuesForEmprise(self, zWidget, zLine, zEmprise, isTableWidget):
        if convertSTR(zEmprise[0], "float") and convertSTR(zEmprise[1], "float") and convertSTR(zEmprise[2], "float") and convertSTR(zEmprise[3], "float") :
           affectEmprise = (float(zEmprise[3]), float(zEmprise[1]), float(zEmprise[0]), float(zEmprise[2]))
        else : return
        
        if isTableWidget :
            for i in range(4): zWidget.cellWidget(zLine, i).setValue(affectEmprise[i])
        else :
            i = 0
            for child in self.Metadata.children():
                if child.metaObject().className() == "MySpinBox" :
                   child.setValue(affectEmprise[i]) 
                   i+= 1


    def MakeOpenLink(self):
        zUrl = self.ToOpenLink
        if self.sender() == self.openURLinNewTab : self.dialog.addNewTab()
        reLinked = False
        if self.dialog.eURL.findText(zUrl)==-1 : self.dialog.eURL.addItem(zUrl)
        else : reLinked = True
        self.dialog.eURL.setCurrentIndex(self.dialog.eURL.findText(zUrl))
        self.current_url = QUrl(zUrl)
        if reLinked : ActiveLink(self.dialog, self.current_url, True, self)

    
    def MakeOpenURL(self):
        try : webbrowseropen(self.ToOpenURL)
        except :
            zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
            zMsg = QApplication.translate("QSphere","Try to open Web navigator for https protocol ...", None, QApplication.UnicodeUTF8)
            SendMessage(self.dialog, zTitle , zMsg, QgsMessageBar.WARNING, 3)
        
    def MakeToCopy(self): QApplication.clipboard().setText(self.ToCopy)
    def MakeToCopyURL(self): QApplication.clipboard().setText(self.ToCopyURL)
    def MakeToPaste(self): self.page().triggerAction(QWebPage.Paste)
    def SelectAll(self): self.page().triggerAction(QWebPage.SelectAll)
    
    def GoLink(self, url):
        reLinked = False
        self.isPageOkLoaded = False
        self.dialog.startMovie()
        self.dialog.labelResultFiles.setVisible(True)
        zUrl = url.toString()
        if self.dialog.eURL.findText(zUrl)==-1 : self.dialog.eURL.addItem(zUrl)
        else : reLinked = True
        self.dialog.eURL.setCurrentIndex(self.dialog.eURL.findText(zUrl))
        self.current_url = url
        if reLinked : ActiveLink(self.dialog, self.current_url, True, self)

def load_source(url, dialog):
    page = QWebPage()
    page.settings().setAttribute(QWebSettings.AutoLoadImages, False)
    page.mainFrame().setUrl(QUrl(url))

    class State(QObject):
        src = None
        finished = False

        @pyqtSlot()
        def loaded(self, success=True):
            self.finished = True
            if self.src is None:
                self.src = page.mainFrame().toHtml()
    state = State()

    def js():
        page.mainFrame().addToJavaScriptWindowObject('qstate$', state)
        page.mainFrame().evaluateJavaScript('''
            document.addEventListener('DOMContentLoaded', qstate$.loaded);
        ''')
    page.mainFrame().javaScriptWindowObjectCleared.connect(js)

    page.mainFrame().loadFinished.connect(state.loaded)

    while not state.finished: QApplication.processEvents() 

    return state.src



def FixeEnabledHistory(zDialog, MyWebView):
    zDialog.BackButton.setEnabled(True) if MyWebView.history().backItems(100) else zDialog.BackButton.setEnabled(False)
    zDialog.FowardButton.setEnabled(True) if MyWebView.history().forwardItems(100)  else zDialog.FowardButton.setEnabled(False)

def CheckingListeXSLT(self, url):
    if self.listeXSLT == [] and url.startswith("filexml:"): url = url.replace("filexml:", "")
    return url   
    
def ActiveLink(zDialog, zUrl, isUnicode, MyWebView) :
        zPath = getThemeIcon(dirname(__file__))
        zAnchor = zDialog.HTML = ""
        isXML = False

        zUrl = CheckingListeXSLT(zDialog, zUrl)
        MyWebView.lastURL = zUrl

        try :
            if isUnicode : zUrl = "%s" % (unicode(zUrl.toString()))
        except : return
        
        if zUrl.find("xml:")!=-1 or zUrl.find("file:")!=-1 :
           zDialog.eURL.setStyleSheet("""QComboBox {background-color:#AEEE00;}"""
                                      """QComboBox QAbstractItemView {background-color:#AEEE00; min-width:%spx;}""" % (zDialog.minwidth)
                                      )
        zDialog.fileExtension, zDialog.isXML, zDialog.iconName = ".html", False, "navigatorweb.png"

    
        if zUrl.find("file:")!=-1 or zUrl.find("fileHTML:")!=-1 :
           refItem = zUrl

           zDialog.iconName = "info.png" 
           zUrl = zUrl.replace("file:///","")
           if zUrl.find("file:")!=-1 : zUrl = zUrl.replace("file:","")
           if zUrl.find("fileHTML:")!=-1 : zUrl = zUrl.replace("fileHTML:","")
           if zUrl.find(".html#")!= -1 :
              zTemp = zUrl.split("#")
              zUrl = zTemp[0]
              zAnchor = zTemp[1]
           MyWebView.setStyleSheet("background-color:rgb(255,255,255); padding: 7px ; color:rgb(255,255,255)")

           zTest, zFileHelp = fileRessourceExist(None, zUrl)
           if zFileHelp == "" :
               zFileHelp = "/ressources/html/%s" % (zUrl)
               zTest, zFileHelp = fileRessourceExist(None, zFileHelp)
           if zFileHelp!= "" :
            
               zText = ""

               if zDialog.emprise!=[]: sEmprise = "<script>var bounds = new OpenLayers.Bounds(%s, %s, %s, %s);</script>" % (zDialog.emprise[2], zDialog.emprise[1], zDialog.emprise[3], zDialog.emprise[0])
               else : sEmprise = "<script>var bounds = new OpenLayers.Bounds(-9.6199999999999992, 41.18, 10.300000000000001, 51.539999999999999);</script>"

               f = codecsopen(zFileHelp, encoding='cp1252') if zUrl.find("fileHTML:")==-1 else  codecsopen(zFileHelp) #test utf_8, utf_32
               try :
                   for line in f: zText+= line
               except : pass

               if zText.find("%SCRIPT_EMPRISE%")!= -1: zText = zText.replace("%SCRIPT_EMPRISE%", sEmprise)
               if zText.find("%LOADER(IMAGES)%")!= - 1:
                  zList = ""
                  zList = listdirectory(MyWebView.parent(), "%s/icons/" % (zPath))
                  zText = zText.replace("%LOADER(IMAGES)%",zList)
               
               baseUrl = QUrl.fromLocalFile(zFileHelp) 
               MyWebView.setHtml(zText, baseUrl)
               
               f.close()
               if zAnchor != "" :
                  zTest = MyWebView.findText(zAnchor)
                  if not zTest : MyWebView.page().mainFrame().scrollToAnchor(zAnchor)

               zDialog.eURL.setCurrentIndex(zDialog.eURL.findText(zFileHelp))
               zDialog.eURL.setStyleSheet("QComboBox {background-color:#AEEE00;}"
                          "QComboBox QAbstractItemView {background-color:#AEEE00; min-width:%spx;}" % (zDialog.minwidth)
                          )               

               
           else : MyWebView.setHtml(QApplication.translate("QSphere", "Resource file missing !", None, QApplication.UnicodeUTF8))
           
        elif zUrl.find("filexml:")!=-1 :
            zDialog.isXML = True
            zDialog.iconName = "viewhtml.png"
            zUrl = zUrl.replace("filexml:","")
            zUrl = unquote(zUrl)

            zDialog.initDir = CorrigePath(dirname(zUrl))
            fileName, zDialog.fileExtension = splitext(zUrl)

            if zDialog.fileExtension.lower() == ".xml" :
                #Primary XSLT
                baseUrl = ""
                qry = QXmlQuery(QXmlQuery.XSLT20)
                zTest, XSL = fileRessourceExist(zDialog, "xml/xsl/%s" % (zDialog.PrimaryXSLT.currentText()))
                if XSL!= "" : baseUrl = QUrl.fromLocalFile(XSL)
                qry.setFocus(QUrl.fromLocalFile(zUrl)) 
                qry.setQuery(QUrl.fromLocalFile(XSL)) 
                HTML = qry.evaluateToString()

                if HTML is None:
                   #Secondary XSLT 
                   zTest, XSL = fileRessourceExist(zDialog, "xml/xsl/%s" % (zDialog.SecondaryXSLT.currentText()))
                   if XSL!= "" : baseUrl = QUrl.fromLocalFile(XSL)
                   qry.setFocus(QUrl.fromLocalFile(zUrl))
                   qry.setQuery(QUrl.fromLocalFile(XSL)) 
                   HTML = qry.evaluateToString()
                   if HTML is None :
                      HTML = QApplication.translate("QSphere", "File parsing XSLT error !<br>Invalid XSLT or XML file !", None, QApplication.UnicodeUTF8)
                      HTML = "<div align='center'><img src='%s'><br><br>%s</div>" % (getThemeIcon("parsing_error.png"), HTML)
                      zDialog.PrimaryXSLT.setStyleSheet("""QComboBox {background: red;}""")
                      zDialog.SecondaryXSLT.setStyleSheet("""QComboBox {background: red;}""")
                   else :
                      HTML = NetHTML(HTML)
                      zDialog.PrimaryXSLT.setStyleSheet("""QComboBox {background: red;}""")
                      zDialog.SecondaryXSLT.setStyleSheet("""QComboBox {background: green;}""")
                      
                else:
                    HTML = NetHTML(HTML)
                    zDialog.PrimaryXSLT.setStyleSheet("QComboBox {background: green;}")
                    zDialog.SecondaryXSLT.setStyleSheet("QComboBox {background: white;}")

                isXML = True
                MyWebView.setHtml(HTML, baseUrl)
                zDialog.HTML = HTML
                zDialog.oldurl = CorrigePath(dirname(baseUrl.toString()))
                
            elif zDialog.fileExtension.lower() == ".qss" :
                isXML = True
                qry = QXmlQuery(QXmlQuery.XSLT20)
                zTest, XSL = fileRessourceExist(zDialog, "xml/xsl/generic_xml.xsl")
                HTML = None
                if XSL!= "" :
                   baseUrl = QUrl.fromLocalFile(XSL)
                   qry.setFocus(QUrl.fromLocalFile(zUrl))
                   qry.setQuery(QUrl.fromLocalFile(XSL)) 
                   HTML = qry.evaluateToString()
                   zIndex = zDialog.listeXSLT.index("generic_xml.xsl")
                   zDialog.PrimaryXSLT.setCurrentIndex(zIndex)
                   
                if HTML is None :
                    HTML = QApplication.translate("QSphere", "File parsing XSLT error !<br>Invalid XSLT or XML file !", None, QApplication.UnicodeUTF8)
                    HTML = "<div align='center'><img src='%s'><br><br>%s</div>" % (getThemeIcon("parsing_error.png"), HTML)
                    zDialog.PrimaryXSLT.setStyleSheet("""QComboBox {background: red;}""")
                    zDialog.SecondaryXSLT.setStyleSheet("""QComboBox {background: red;}""")                    
                else :
                    MyWebView.setHtml(HTML, baseUrl)
                    zDialog.HTML = HTML
                    zDialog.oldurl = CorrigePath(dirname(baseUrl.toString()))
                    zDialog.PrimaryXSLT.setStyleSheet("""QComboBox {background: green;}""")
                    zDialog.SecondaryXSLT.setStyleSheet("""QComboBox {background: red;}""")
                

        elif zUrl == "#blank" :
            if zDialog.eURL.findText(zUrl)==-1 : zDialog.eURL.addItem(zUrl)
            baseUrl = QUrl.fromLocalFile(dirname(__file__))
            MyWebView.setHtml("", baseUrl)
            zDialog.eURL.setStyleSheet("QComboBox {background-color:#AEEE00;}"
                          "QComboBox QAbstractItemView {background-color:#AEEE00; min-width:%spx;}" % (zDialog.minwidth)
                          )
               
        else :

            if zDialog.eURL.findText(zUrl)==-1 : zDialog.eURL.addItem(zUrl)

            if QUrl(zUrl).isValid() :
               zFile = None
               zFileUrl = unquote(zUrl)
               zTestQUERY = False
               if exists(zFileUrl) :
                   zFile = QFileInfo(zFileUrl)
                   zSuffixe = zFile.suffix().lower()
                   zTest = FileIsRaster(zFileUrl)
                   if (zSuffixe not in ("html", "htm", "qsp", "qsr", "csv") and not zTest) or (zSuffixe in ("ecw", "jp2", "view") and zTest): 
                       baseUrl = QUrl.fromLocalFile(zFileUrl)
                       HTML = MakeFileInfosToHTML(zDialog, zFile) 
                       MyWebView.setHtml(HTML, baseUrl)
                       MyWebView.ToOpenURL = zFileUrl 
                       return
               else : 
                   zElts, zQueryURL, zTestQUERY = zUrl.split("/"), [], False
                   zQueryURL = zElts[-1].split("=")
                   if zQueryURL != [] : 
                      if zQueryURL[0] in zDialog.ListOfqueryURL : zTestQUERY = True
                   
               if zTestQUERY :                   
                   MyWebView.telech = Telecharge(QUrl(zUrl), zDialog, None, "*.xml", zDialog.duration_info, zDialog.duration_warning, False) 
                   MyWebView.telech.fintelecharge.connect(MyWebView.telecharge_ok) 
               else :
                       zDialog.eURL.setStyleSheet("QComboBox {background-color:#AEEE00;}"
                                  "QComboBox QAbstractItemView {background-color:#AEEE00; min-width:%spx;}" % (zDialog.minwidth)
                                  )
                        
                       if zFile != None :
                           if zSuffixe in ("qsp", "qsr") :
                              baseUrl = QUrl.fromLocalFile(zUrl)
                              myfile = open(zFileUrl, 'r')
                              myfileText = myfile.readlines()
                              myfile.close()
                              HTML = ""
                              for k in range(len(myfileText)): HTML+= "%s" % (MarkerText(zDialog, myfileText[k]))
                              MyWebView.setHtml(HTML, baseUrl)
                           else :
                              MyWebView.load(QUrl(zUrl))
                       else :
                           try : MyWebView.load(QUrl(zUrl))
                           except : pass
                           
            else :
               zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
               zMsg = QApplication.translate("QSphere","Invalid URL ! Use open function if necessary for local resources ...", None, QApplication.UnicodeUTF8)
               SendMessage(zDialog, zTitle , zMsg, QgsMessageBar.WARNING, zDialog.duration_warning)

        zCond = (zDialog.HTML!="") 
        zDialog.SaveButton.setEnabled(zCond)

        if not isXML : zDialog.oldurl = ""
        FixeEnabledHistory(zDialog, MyWebView)    
        page = MyWebView.page()
        page.setLinkDelegationPolicy(QWebPage.DelegateAllLinks)
        MakeWindowIcon(zDialog, zDialog.iconName)


class Telecharge(QNetworkAccessManager):
    fintelecharge = pyqtSignal(bool)
    def __init__(self, url, dialog, fileName, typeMime, duration_info, duration_warning, silentmode) : 
        QNetworkAccessManager.__init__(self)
        self.initDir = CorrigePath(dirname(__file__))
        self.dialog = dialog
        self.messageBuffer = QByteArray()
        self.fileName, self.typeMime = fileName, typeMime
        self.duration_info = duration_info
        self.duration_warning = duration_warning
        self.silentmode = silentmode
        self.reply = self.get(QNetworkRequest(url))
        self.reply.readyRead.connect(self.readData)
        self.reply.finished.connect(self.finished)
        self.url = url
        self.dialog.startMovie()
        self.dialog.labelResultFiles.setVisible(True)

    @pyqtSlot()
    def readData(self):
        self.messageBuffer+= self.reply.readAll()
        if not self.silentmode :
            self.dialog.labelResultFiles.setText("%s" % convertSize(len(self.messageBuffer))) #zMsg)
            self.dialog.labelResultFiles.repaint()

 
    @pyqtSlot()
    def finished(self):
        self.dialog.barInfo.clearWidgets()
        self.dialog.barInfo.setVisible(False)
        self.dialog.stopMovie()
        self.dialog.labelResultFiles.setVisible(False)
        
        filtermime = "*.*" if self.typeMime == None else self.typeMime
        initDir = self.initDir if self.fileName == None else "%s%s" % (self.initDir, self.fileName)

        if not filtermime in ("*.htm", "*.xml", "*.html") :
           if filtermime == "*.*" :
               typemime, filtermime = "%s" % (self.reply.header(0)), "*.*"
               if typemime.find(";")!=-1 :
                   typemime = typemime.rsplit(";",1)[0]
                   if typemime.find("/")!=-1 :
                      filtermime = "*.%s" % (typemime.rsplit("/",1)[1].lower()) 
           self.saveFile(filtermime)
           return


        #For XML
        if filtermime == "*.*" :
           typemime, filtermime = "%s" % (self.reply.header(0)), "*.*"
           if typemime.find(";")!=-1 :
               typemime = typemime.rsplit(";",1)[0]
               if typemime.find("/")!=-1 :
                  filtermime = "*.%s" % (typemime.rsplit("/",1)[1].lower())


        if filtermime == "*.xml" :
            dataXML = StringIO(self.messageBuffer)
            try :
                tree = ET.parse(dataXML)
                root = tree.getroot()
            except : tree, root = None, None

            if root == None :
                zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
                zMsg = QApplication.translate("QSphere","Error on download stream ", None, QApplication.UnicodeUTF8) 
                SendMessage(self.dialog, zTitle , "%s :\n%s" % (zMsg, self.messageBuffer), QgsMessageBar.INFO, self.duration_info)
                return

            self.fileName = ""

            if root.tag == '{http://www.isotc211.org/2005/gmd}MD_Metadata':
                   myISO = xmlISOparser(None, StringIO(self.messageBuffer) , 'MEDDE', 'fr') 
                   myISO.createISOdataStructure(True)

                   if myISO.getTagDictionnary() :
                               
                               try : zObjRef = self.dialog.parent
                               except : zObjRef = None
                               if not zObjRef : return

                               from doUI import DialogMetadata
                               from qsphere_tools import getThemeIcon
                               
                               zTitle = QApplication.translate("QSphere","Request for confirmation", None, QApplication.UnicodeUTF8)
                               zMsg = QApplication.translate("QSphere","Directly Load Data in Main Window ?", None, QApplication.UnicodeUTF8)
                               zYes = QApplication.translate("QSphere","Yes", None, QApplication.UnicodeUTF8)
                               zNo = QApplication.translate("QSphere","No", None, QApplication.UnicodeUTF8)

                               MyMsgBoxDialog = QMessageBox(self.dialog)

                               MyMsgBoxDialog.setWindowTitle(zTitle)
                               MakeWindowIcon(MyMsgBoxDialog, "navigatorweb.png")
                               MyMsgBoxDialog.setIcon(QMessageBox.Question)
                               

                               groupBox1 = QGroupBox(MyMsgBoxDialog)
                               groupBox1.setFixedSize(420, 250)
                               groupBox1.setObjectName("groupBox1")

                               zCond, child = False, None
                               #QSphere 4.2.0
                               from ui_mainwindow import myMDIWindow
                               if type(zObjRef)== myMDIWindow :
                                   try : zObjRef = zObjRef.parent()
                                   except :
                                        try : zObjRef = zObjRef.parent
                                        except : return
                               
                               if zObjRef.mainWindow :
                                  dialog, child = zObjRef.mainWindow.fixeMDDWindow()
                                  if type(child)==DialogMetadata : zCond = True
                               
                               labelImage = QLabel(groupBox1)
                               myImgPath = getThemeIcon("help.png")
                               carIcon = QImage(myImgPath)
                               labelImage.setPixmap(QPixmap.fromImage(carIcon))
                               labelImage.setGeometry(145, 10, 128, 108)

  
                               zRadioButton1 = QRadioButton(groupBox1)
                               zRadioButton1.setObjectName("zRadioButton1")
                               zRadioButton1.setAccessibleName("zRadioButton1")
                               zRadioButton1.setFixedSize(420, 25)
                               zRadioButton1.setGeometry(5, 115, 420, 25)
                               zRadioButton1.setText("%s" % (QApplication.translate("QSphere","Directly Load Data in Main Window ?", None, QApplication.UnicodeUTF8)))
                               zRadioButton1.setEnabled(zCond)
                               zRadioButton1.setChecked(False)
 

                               zRadioButton2 = QRadioButton(groupBox1)
                               zRadioButton2.setObjectName("zRadioButton2")
                               zRadioButton2.setAccessibleName("zRadioButton2")
                               zRadioButton2.setFixedSize(420, 25)
                               zRadioButton2.setGeometry(5, 150, 420, 25)
                               zRadioButton2.setText("%s" % (QApplication.translate("QSphere","Open a new Main Window ?", None, QApplication.UnicodeUTF8)))
                               zRadioButton2.setChecked(True)

                               zRadioButton3 = QRadioButton(groupBox1)
                               zRadioButton3.setObjectName("zRadioButton3")
                               zRadioButton3.setAccessibleName("zRadioButton3")
                               zRadioButton3.setFixedSize(420, 25)
                               zRadioButton3.setGeometry(5, 180, 420, 25)
                               zRadioButton3.setText("%s" % (QApplication.translate("QSphere","Save file as ...", None, QApplication.UnicodeUTF8))) 

                               zRadioButton4 = QRadioButton(groupBox1)
                               zRadioButton4.setObjectName("zRadioButton4")
                               zRadioButton4.setAccessibleName("zRadioButton4")
                               zRadioButton4.setFixedSize(420, 25)
                               zRadioButton4.setGeometry(5, 210, 420, 25)
                               zRadioButton4.setText("%s" % (QApplication.translate("QSphere", "Open link in my default navigator", None, QApplication.UnicodeUTF8))) 
    
                               zButtonAccept = QPushButton(MyMsgBoxDialog)
                               zButtonAccept.setObjectName("SaveButton")
                               zButtonAccept.setText(QApplication.translate("QSphere", "Apply", None, QApplication.UnicodeUTF8))
                               zButtonAccept.setFixedSize(100, 25)

                               zButtonReject = QPushButton(MyMsgBoxDialog)
                               zButtonReject.setObjectName("CloseButton")
                               zButtonReject.setText(QApplication.translate("QSphere", "Close", None, QApplication.UnicodeUTF8))
                               zButtonReject.setFixedSize(100, 25)

                               zButtonAccept.clicked.connect(MyMsgBoxDialog.accept)
                               zButtonReject.clicked.connect(MyMsgBoxDialog.reject)
                               

                               MyMsgBoxDialog.layout().addWidget(groupBox1,0,1,1,2)
                               MyMsgBoxDialog.layout().addWidget(zButtonAccept,4,1,1,1)
                               MyMsgBoxDialog.layout().addWidget(zButtonReject,4,2,1,1)

                               MyMsgBoxDialog.setStandardButtons(MyMsgBoxDialog.NoButton)

                               #ONE INSTANCE OR PERSISTENT ?
                               #ret = MyMsgBoxDialog.exec_()
                              
                               result = False
                               while True :
                                   ret = MyMsgBoxDialog.exec_()
                                   if ret == 1 :

                                      if zRadioButton1.isChecked() : 
                                           if child :
                                              zIndex = child.tabWidget.currentIndex()
                                              result = child.ReloadDataFromXML(myISO, None, zIndex)
                                      
                                      elif zRadioButton2.isChecked() :
                                           from doUI import DialogMetadata

                                           zObjRef = self.dialog.parent
                                           if not zObjRef : return

                                           if type(zObjRef) != myMDIWindow :
                                               if not zObjRef.mainWindow :
                                                   from ui_mainwindow import myMDIWindow
                                                   zObjRef.mainWindow = myMDIWindow(zObjRef.MainPlugin)
                                                   zObjRef.mainWindow.setWindowState(Qt.WindowMaximized)
                                                   zObjRef.mainWindow.show()
                                                   dialogMDD, mdiWindow =  zObjRef.mainWindow.newMetadataFile()
                                           else :
                                               zObjRef.show()
                                               dialogMDD, mdiWindow =  zObjRef.newMetadataFile()

                                           

                                           
                                           if mdiWindow != None : 
                                              for child in mdiWindow.children():
                                                  if type(child)==DialogMetadata :
                                                     zIndex = child.tabWidget.currentIndex()
                                                     result = child.ReloadDataFromXML(myISO, None, zIndex)
                                           zRadioButton1.setEnabled(True)
                                           
                                      elif zRadioButton4.isChecked() :
                                           self.dialog.mainTabWidget.currentWidget().viewHTML.ToOpenURL = self.reply.url().toString()
                                           self.dialog.mainTabWidget.currentWidget().viewHTML.MakeOpenURL()
                                           
                                      elif zRadioButton3.isChecked() :
                                           zCond, self.fileName = False, "*.xml"
                                           try :
                                               self.fileName = "%s.xml" % (myISO.UUID[0][0]) if myISO.UUID[0][0]!="" else "*.xml"
                                           except :
                                               for child in root :
                                                   if "fileIdentifier" in child.tag :
                                                       for elVal in child:
                                                           self.fileName = "%s.xml" % (elVal.text)
                                                           zCond = True
                                                   if zCond : break
                                           finally : pass
                                           self.saveFile(filtermime)

                                   else : return   


    def saveFile(self, filtermime):

       if len(self.messageBuffer) > 0 :

          zTitle = QApplication.translate("QSphere","Save file as ...", None, QApplication.UnicodeUTF8)
          MyFileDialog = QFileDialog(self.dialog, zTitle)

          if filtermime!= "*.*" : MyFileDialog.setDefaultSuffix(filtermime.split(".")[1])
          MyFileDialog.setNameFilters((filtermime,))
          MyFileDialog.selectNameFilter(filtermime)
          MyFileDialog.selectFile(self.fileName.replace(":", "-"))
          MyFileDialog.setViewMode(QFileDialog.Detail)
          MyFileDialog.setDirectory(self.initDir)
          MyFileDialog.setAcceptMode(QFileDialog.AcceptSave)

          FixeLabelsFileDialog(self, MyFileDialog, 1, True)
          
          if MyFileDialog.exec_():
                fileName = FileNameWithExtension(self, MyFileDialog.selectedFiles()[0], MyFileDialog.selectedNameFilter())          
                self.initDir = dirname(fileName)
                saveFile = QFile(fileName)
                zTitle = QApplication.translate("QSphere","Information", None, QApplication.UnicodeUTF8)
                if (saveFile.open(QIODevice.WriteOnly)):
                    saveFile.write(self.messageBuffer)
                    saveFile.close()
                    self.dialog.viewHTML.fileName = fileName
                    self.fintelecharge.emit(True)
                else:
                    self.fintelecharge.emit(False)

       elif len(self.messageBuffer) == 0 :       

            zTitle = QApplication.translate("QSphere","Warning", None, QApplication.UnicodeUTF8)
            zMsg = QApplication.translate("QSphere","Some troubleshooting to download the file ", None, QApplication.UnicodeUTF8)
            zMsg1 = QApplication.translate("QSphere", "Open link in my default navigator", None, QApplication.UnicodeUTF8)

            if QMessageBox.question(None, zTitle, "%s :\n%s\n%s ?" % (zMsg, self.url.toString(), zMsg1),
               QApplication.translate("QSphere","Validate", None, QApplication.UnicodeUTF8),
               QApplication.translate("QSphere","Cancel", None, QApplication.UnicodeUTF8)) ==  0 : 

               try : webbrowseropen(unicode(self.url.toString()))
               except : pass
